// sapienCtrl.cpp : Implementation of the CsapienCtrl ActiveX Control class.


#include "sapienocx.h"
#include "sapienCtrl.h"
#include "sapienPpg.h"
#include ".\sapienctrl.h"
#include "../sapien/sapien.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


IMPLEMENT_DYNCREATE(CsapienCtrl, COleControl)



// Message map

BEGIN_MESSAGE_MAP(CsapienCtrl, COleControl)
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()



// Dispatch map

BEGIN_DISPATCH_MAP(CsapienCtrl, COleControl)
	DISP_FUNCTION(CsapienCtrl, "open", open, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION(CsapienCtrl, "close", close, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CsapienCtrl, "decode", decode, VT_I2, VTS_BSTR VTS_I2)
	DISP_FUNCTION(CsapienCtrl, "send", send, VT_EMPTY, VTS_I2 VTS_I2)
END_DISPATCH_MAP()

// Event map
BEGIN_EVENT_MAP(CsapienCtrl, COleControl)
END_EVENT_MAP()



// Property pages
// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CsapienCtrl, 1)
	PROPPAGEID(CsapienPropPage::guid)
END_PROPPAGEIDS(CsapienCtrl)


// Initialize class factory and guid
IMPLEMENT_OLECREATE_EX(CsapienCtrl, "sapien",
	0x8eb07cca, 0xe4c4, 0x40be, 0xba, 0xc8, 0xd0, 0xcf, 0x86, 0x8d, 0x11, 0x1)

// Type library ID and version
IMPLEMENT_OLETYPELIB(CsapienCtrl, _tlid, _wVerMajor, _wVerMinor)


// Interface IDs
const IID BASED_CODE IID_Dsapienocx =
		{ 0xBBE12716, 0xE141, 0x4A2F, { 0xAC, 0xBE, 0x8B, 0x44, 0xCF, 0x7D, 0x2F, 0xCE } };
const IID BASED_CODE IID_DsapienocxEvents =
		{ 0xACF1DFDE, 0x300, 0x4E5C, { 0xB3, 0x46, 0xED, 0x18, 0xCE, 0xDC, 0x26, 0xD5 } };

// Control type information
static const DWORD BASED_CODE _dwsapienocxOleMisc =
	OLEMISC_INVISIBLEATRUNTIME |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CsapienCtrl, IDS_SAPIENOCX, _dwsapienocxOleMisc)

// CsapienCtrl::CsapienCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CsapienCtrl
BOOL CsapienCtrl::CsapienCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegApartmentThreading to 0.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_SAPIENOCX,
			IDB_SAPIENOCX,
			afxRegApartmentThreading,
			_dwsapienocxOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}

// CsapienCtrl::CsapienCtrl - Constructor
CsapienCtrl::CsapienCtrl()
{
	InitializeIIDs(&IID_Dsapienocx, &IID_DsapienocxEvents);
	// Initialize your control's instance data here.
	initialized = 0;
}



// CsapienCtrl::~CsapienCtrl - Destructor
CsapienCtrl::~CsapienCtrl()
{
	// Cleanup your control's instance data here.
	if (initialized) sap_close(handle);
	initialized = 0;
}

// CsapienCtrl::OnDraw - Drawing function
void CsapienCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	if (!pdc)
		return;

	// VC++ says: Replace the following code with your own drawing code.
	// pdc->FillRect(rcBounds, CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH)));
	// pdc->Ellipse(rcBounds);
}

// CsapienCtrl::DoPropExchange - Persistence support
void CsapienCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);
	// Call PX_ functions for each persistent custom property.
}

// CsapienCtrl::GetControlFlags -
// Flags to customize MFC's implementation of ActiveX controls.
//
DWORD CsapienCtrl::GetControlFlags()
{
	DWORD dwFlags = COleControl::GetControlFlags();


	// The control can activate without creating a window.
	// NOTE: when writing the control's message handlers, avoid using
	//		the m_hWnd member variable without first checking that its
	//		value is non-NULL.
	dwFlags |= windowlessActivate;
	return dwFlags;
}



// CsapienCtrl::OnResetState - Reset control to default state

void CsapienCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange
	// Reset any other control state here.
}



// sends the specified code through the IR tower
void CsapienCtrl::send(int code, int nowakeup)
{
  if (initialized) sap_send(handle, nowakeup, code);
}

// converts command of given name to hexcode
int CsapienCtrl::decode(LPCSTR sapien_cmd, int version)
{
  return sap_decode(sapien_cmd, version);
}

// opens port with IR tower (such as COM1) and initializes 
void CsapienCtrl::open(LPCTSTR port)
{
  handle = sap_open(port);
  if (handle != INVALID_HANDLE_VALUE) initialized = 1;
}

// close the IR tower port
void CsapienCtrl::close(void)
{
	if (initialized) sap_close(handle);
	initialized = 0;
}
